/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the NotificationAssetCreatable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NotificationAssetCreatable{}

// NotificationAssetCreatable struct for NotificationAssetCreatable
type NotificationAssetCreatable struct {
	Type *string `json:"type,omitempty"`
	Translations []NotificationAssetTranslation `json:"translations,omitempty"`
}

// NewNotificationAssetCreatable instantiates a new NotificationAssetCreatable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotificationAssetCreatable() *NotificationAssetCreatable {
	this := NotificationAssetCreatable{}
	return &this
}

// NewNotificationAssetCreatableWithDefaults instantiates a new NotificationAssetCreatable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationAssetCreatableWithDefaults() *NotificationAssetCreatable {
	this := NotificationAssetCreatable{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *NotificationAssetCreatable) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NotificationAssetCreatable) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *NotificationAssetCreatable) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *NotificationAssetCreatable) SetType(v string) {
	o.Type = &v
}

// GetTranslations returns the Translations field value if set, zero value otherwise.
func (o *NotificationAssetCreatable) GetTranslations() []NotificationAssetTranslation {
	if o == nil || IsNil(o.Translations) {
		var ret []NotificationAssetTranslation
		return ret
	}
	return o.Translations
}

// GetTranslationsOk returns a tuple with the Translations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NotificationAssetCreatable) GetTranslationsOk() ([]NotificationAssetTranslation, bool) {
	if o == nil || IsNil(o.Translations) {
		return nil, false
	}
	return o.Translations, true
}

// HasTranslations returns a boolean if a field has been set.
func (o *NotificationAssetCreatable) HasTranslations() bool {
	if o != nil && !IsNil(o.Translations) {
		return true
	}

	return false
}

// SetTranslations gets a reference to the given []NotificationAssetTranslation and assigns it to the Translations field.
func (o *NotificationAssetCreatable) SetTranslations(v []NotificationAssetTranslation) {
	o.Translations = v
}

func (o NotificationAssetCreatable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NotificationAssetCreatable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Translations) {
		toSerialize["translations"] = o.Translations
	}
	return toSerialize, nil
}

type NullableNotificationAssetCreatable struct {
	value *NotificationAssetCreatable
	isSet bool
}

func (v NullableNotificationAssetCreatable) Get() *NotificationAssetCreatable {
	return v.value
}

func (v *NullableNotificationAssetCreatable) Set(val *NotificationAssetCreatable) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationAssetCreatable) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationAssetCreatable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationAssetCreatable(val *NotificationAssetCreatable) *NullableNotificationAssetCreatable {
	return &NullableNotificationAssetCreatable{value: val, isSet: true}
}

func (v NullableNotificationAssetCreatable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationAssetCreatable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


